/*
 * Ouroboros - Copyright (C) 2016 - 2017
 *
 * Quality of Service specification
 *
 *    Dimitri Staessens <dimitri.staessens@ugent.be>
 *    Sander Vrijders   <sander.vrijders@ugent.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301 USA
 */

#ifndef OUROBOROS_QOS_H
#define OUROBOROS_QOS_H

#include <stdint.h>
#include <stdbool.h>

typedef struct qos_spec {
        uint32_t delay;                /* In ms */
        uint64_t bandwidth;            /* In bits/s */
        uint8_t  availability;         /* Class of 9s */
        uint32_t maximum_interruption; /* In ms */

        bool     resource_control;     /* Feedback from receiver */
        bool     reliable;             /* Reliable flow */
        bool     error_check;          /* Check for errors */
        bool     ordered;              /* Ordered delivery */
        bool     partial;              /* Allow partial delivery */
} qosspec_t;

int qosspec_init(qosspec_t * qs);
int qosspec_fini(qosspec_t * qs);

#endif
