/*
 * Ouroboros - Copyright (C) 2016 - 2017
 *
 * Address authority
 *
 *    Dimitri Staessens <dimitri.staessens@ugent.be>
 *    Sander Vrijders   <sander.vrijders@ugent.be>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#define OUROBOROS_PREFIX "addr_auth"

#include <ouroboros/config.h>
#include <ouroboros/logs.h>

#include "addr_auth.h"
#include "pol-addr-auth-ops.h"
#include "pol/flat.h"

#include <stdlib.h>
#include <assert.h>

struct addr_auth {
        struct pol_addr_auth_ops * ops;
} addr_auth;

int addr_auth_init(enum pol_addr_auth type)
{
        switch (type) {
        case FLAT_RANDOM:
                addr_auth.ops = &flat_ops;
                break;
        default:
                log_err("Unknown address authority type.");
                return -1;
        }

        return addr_auth.ops->init();
}

uint64_t addr_auth_address(void)
{
        return addr_auth.ops->address();
}

int addr_auth_fini(void)
{
        return addr_auth.ops->fini();
}
